classdef suspensions < handle
    % forces on car-body from springs / dampeners
    % as a function of y 
    % for front and rear axle
    
    properties
        a
        sinphi
        cosphi
        singamma
        cosgamma
        u % coordinates (y[1:2])
        v % velocities  (y[4:5])
        phi % y(3)
        phiP % y(6)
        DU
        DUP
    end
    
    methods
        function obj = contacts(car)
            % constructor class
            % read hashMap
            obj.F0   = [car('F[0,1]'),car('F[0,2]')];
            obj.k    = [car('k[1]'),car('k[2]')];
            obj.eps  = car('eps'); 
            obj.R    = car('R');
            obj.omega= car('R');
            obj.a    = [car('a[1]'),car('a[2]'),car('a[3]')]; % drop a[0]
            obj.vRef = car('v[ref]');
            obj.spring = [characteristic([-1 -obj.eps +obj.eps 1],[0 0 obj.F0(1)+obj.k(1)*obj.eps obj.F0(1)+obj.k(1)*1],[obj.eps obj.eps],'Spring 1','Du/L->','F/(M*L/T^2)->'),...
                          characteristic([-1 -obj.eps +obj.eps 1],[0 0 obj.F0(2)+obj.k(2)*obj.eps obj.F0(2)+obj.k(2)*1],[obj.eps obj.eps],'Spring 2','Du/L->','F/(M*L/T^2)->')];
            obj.mu   = characteristic([-1 -0.02 -0.001 +0.001 +0.02 +1],...
                                      [-car('mu') -car('mu') -car('mu0') +car('mu0') +car('mu') +car('mu')],...
                                      [0.005 0.0003 0.0003 0.005],...
                                        'Friction','v/(L/T)','mu/1');
            obj.section = [1,1]; % section where axles had last contact with track (start with "1")
            obj.localTrack = []; %linear polynomial of track at contact)
        end

        function Ft = suspensionForce(obj, y)
           % computes the force in the suspension system
           
           
           
           
           Du[3]=(-2*obj.a[3]*cosphi-u[4]+u[2])*sinphi-2*a[1]*cosphi^2+(u[3]-u[1])*cosphi+a[1],
           Du[4]=(-2*a[1]*cosphi+u[3]-u[1])*sinphi+2*obj.a[3]*cosphi^2+(u[4]-u[2])*cosphi-obj.a[3],
           Du[5]=(-2*obj.a[3]*cosphi-u[6]+u[2])*sinphi+2*a[2]*cosphi^2+(u[5]-u[1])*cosphi-a[2],
           Du[6]=(2*a[2]*cosphi+u[5]-u[1])*sinphi+2*obj.a[3]*cosphi^2+(u[6]-u[2])*cosphi-obj.a[3]
           
           
           
           
           
                     
        end
        
        function Fq = crossForce(obj, y)
            % computes the force perpendicular to the suspension system
    
        end
    end
end

