function dydt = jumpdydt(t,y,parC,parN,b,c,d,e,f)
% implementation of ode
% params hold system parameters

% assign state variables to "meaningful" symbols
f.putY(y');

%% contact forces
% axle one 
xi = f.getContactGeometry(1);
[FN(1), FT] = f.contactF(1);
% axle two 
xi = f.getContactGeometry(2);
[FN(2), ~] = f.contactF(2); % FT is a dummy - not used

%% driving torque
MW = c.R*e.torque(f);

%% battery
dydt(1:3, 1) = b.rightHandSides(d,f);

%% car-body
% right-hand-side A*q' = rhs(q)
rhs = c.rightHandSides(y, MW, FN, FT, f.singamma, f.cosgamma, f.gamma);

dydt(3+1:3+6, 1) = c.invM*rhs(1:6);

% coordinates
for i=1:5
    dydt(3+6+i,1) = y(3+i);
end

%% driver controls
err = min(d.errorfct(f));
dydt(15, 1) = err(1);

%% e-motor and drive-train
dydt(16, 1) = e.rightHandSides(d,f);

%% 
waitbar(t / parN('tEnd'));

end

