function [constants,numerics,batteryData,carData,driverData,eMotorData,contactFcts] = prepro(fileName)
% preprocessor
% get lab parameter from file and compile data, functions, classes

%% get dimensions for potential dimless representation of EOMs
dim = dimensions();

%% read excel file sheets
% sheets to read:
sheetNames=["constants" "numerics" "road" "battery" "car-body" "driver-controls" "e-motor and drive-train"];
% read and put intp arrazs with the same name
for sheetNo = 1:size(sheetNames,2)
    disp(strcat('... reading: ',sheetNames(sheetNo)));
    table=readtable(fileName,'Sheet',sheetNames(sheetNo));
    data = table(:,{'id','name','value','unit','comment'});
    % use a hashmap for params, see https://www.mathworks.com/help/matlab/ref/containers.map.html
    tmp = containers.Map('KeyType','char','ValueType','double');
    % see https://de.mathworks.com/matlabcentral/answers/157563-find-string-within-cell-array
    % read all parameter into params
    for row=1:size(data)
        tmp(data(row,:).name{1}) = data(row,:).value*dim(data(row,:).unit{1});
    end
    % copy container from tmp to sheet-name
    eval(strcat(strrep(strrep(sheetNames(sheetNo),'-','_'),' ','_'),"= tmp;"));
end

%% battery class
batteryData = batteries(battery);
%drive.initialize();

%% car class
% add derived parameters
car_body('a[2]')=car_body('a[0]')-car_body('a[1]');
car_body('J[1]')=car_body('r[b]')^2*car_body('m[1]');
car_body('J[2]')=car_body('r[w]')^2*car_body('m[2]');
car_body( 'g'  )=constants('g');
% car class
carData = cars(car_body);
carData.initialize();

%% driveTrain class
eMotorData = driveTrains(e_motor_and_drive_train);
eMotorData.initialize();
eMotorData.addContributionToMassMatrix(carData);

%% contact class
contactFcts = contacts(car_body);
contactFcts.initialize(road);

%% driver class
driverData = controls(driver_controls);
driverData.initialize(contactFcts);

end



