%%
% code for Matlab R2020a 
% last updated: 2021-03-11
% author: Andreas Baumgart
%% 
% allow display of warning-messages
clear all;clc;warning('on');
% set paths .... (adapt accordingly)
cd 'C:\Users\andreas20H\OneDrive - haw-hamburg.de\Confluence Sources\JUMP\Matlab\rev 05\';

% Functions are in folder 'Functions'
addpath('Functions');
addpath('Classes');

%% preprocess
[parC,parN,b,c,d,e,f] = prepro('params.xlsx');
% test program
%testing(f);

%% solve IVP
% set-up hash-map for numerical paramters
tspan = [0 parN('tEnd')];
v0 = [0;0;0;0];
u0 = [-10.;0.2;0;0];
y0    = [b.QB0;0;b.T0; ... % battery
         v0(1);v0(2);v0(3);v0(4);0.0; 0.0;u0(1);u0(2);u0(3);u0(4);0.0; ...% car
         0; ...     % driver 
         0];        % e-motor
% options = odeset('RelTol',1e-5,'Stats','on')
h = waitbar(0,'solving ODE - please wait...');
%
[t,y] = ode15s(@(t,y)jumpdydt(t,y,parC,parN,b,c,d,e,f),tspan,y0);
close(h)

%% postprocess
postpro(t,y,b,c,d,e,f)
